c....&...1.........2.........3.........4.........5.........6.........7..
      implicit none
c ngrmx = maximum number of pixels (can be changed by user) 
      integer ngrmx,ngr_car,ndmx,nd,ngr_GCM,iday,iday1,iday2,nm,im     
      parameter(ngrmx=10000,ndmx=366,nm=12)      
      common /earth/ radius,pi180
      real*8 radius,pi180       
      integer iyr,iyear,ileap,icentury,iyr1,iyr2,mlength(nm)
      real*4 r100,r4                 
      real*8 xlg(ngrmx),xlt(ngrmx)
     &      ,elev(ngrmx),wgh(ngrmx),land(ngrmx)
      real*8 elvp(ngrmx),temp(ngrmx,ndmx),prcp(ngrmx,ndmx)
     &      ,shrp(ngrmx,ndmx),solp(ngrmx,ndmx),rhup(ngrmx,ndmx)
     &      ,dtep(ngrmx,ndmx),tmxp(ngrmx,ndmx)
     &      ,tmnp(ngrmx,ndmx),wndp(ngrmx,ndmx)     
     &      ,tem1(ngrmx,ndmx),prc1(ngrmx,ndmx)
     &      ,shr1(ngrmx,ndmx),sol1(ngrmx,ndmx),rhu1(ngrmx,ndmx)
     &      ,dte1(ngrmx,ndmx),tmx1(ngrmx,ndmx)
     &      ,tmn1(ngrmx,ndmx),wnd1(ngrmx,ndmx)
      real*8 tem0(nm),prc0(nm),shr0(nm),sol0(nm)
     &      ,rhu0(nm),dte0(nm),tmx0(nm),tmn0(nm),wnd0(nm)
     &      ,tema(nm),prec(nm),rhum(nm),tmin(nm),tmax(nm)
     &      ,wind(nm),dtem(nm),sunh(nm),fsol(nm)     
      real*8 temcor(ndmx),prccor(ndmx),shrcor(ndmx)
     &      ,solcor(ndmx),rhucor(ndmx),dtecor(ndmx)
     &      ,tmxcor(ndmx),tmncor(ndmx),wndcor(ndmx)
     &      ,temact(ndmx),prcact(ndmx),shract(ndmx)
     &      ,solact(ndmx),rhuact(ndmx),dteact(ndmx)
     &      ,tmxact(ndmx),tmnact(ndmx),wndact(ndmx)
     &      ,temlgm(ndmx),prclgm(ndmx),shrlgm(ndmx)
     &      ,sollgm(ndmx),rhulgm(ndmx),dtelgm(ndmx)
     &      ,tmxlgm(ndmx),tmnlgm(ndmx),wndlgm(ndmx)
      real*8 tema1(ndmx),prec1(ndmx),rhum1(ndmx)
     &      ,wind1(ndmx),dtem1(ndmx),sunh1(ndmx),fsol1(ndmx)
     &      ,tmax1(ndmx),tmin1(ndmx),dvdz(ndmx)
     
      real*8 dist(ngrmx),elv,dangl,dist2
      real*8 xlo,xla,xlt1,xlg1,xlt2,xlg2,ylg,ylt,dlg,dlt
      integer igri(ngrmx)
      integer ig,itest,ird_tmax,ird_sol,icount,kg
      integer npoints,npdv,jdv,num,ntry
      common /mth/ imonth(ndmx)
      integer imonth 
      
      real*8 tcrit,tmini,pcrit,pmin,scrit,smin,rcrit,rmin,dcrit,dmin
     &      ,wcrit,wmin     
      
      character*40 wform 

      character*4 year
      character*200 out_dir,GCMm_dir,GCMd_dir,elv_dir,car_dir      

c ird_tmax = 0 reads and interpolates dte for high resolution 
c            climatological values
c ird_tmax = 1 reads and interpolates tmin & tmax for high resolution 
c            climatological values      

      ileap = 1

      ngr_GCM=55
      ngr_car=17229

      iyr1=1901
      iyr2=2010  
      
      npoints=4
      npdv=20 
      
      open(7,file='./anom.test') 
      
      radius = 6370.                
      
      do iyear = iyr1, iyr2

        if (ileap.eq.0) then
	 nd = 365
	elseif  (ileap.eq.1) then
         r100 = mod(iyear,100)
         if (r100.eq.0) then
          icentury = iyear/100
	  r4 = mod(icentury,4)
         else     
          r4 = mod(iyear,4)
         endif 
         if (r4.eq.0) then 
          nd = 366 
         else
	  nd = 365
         endif
	elseif  (ileap.eq.2) then 
	 nd = 360
	else
	 write(*,*)'ILEAP not equal to 0, 1 or 2: ILEAP = ',ileap
	 write(*,*)'PROGRAM STOP'
	 stop
        endif
                  
       write(year,'(i4)') iyear   
       write(*,*)'Year: ',iyear
       
       if (ileap.eq.2) then
        do im = 1, nm
         mlength(im)=30
        end do
       else
        mlength(1)=31
        mlength(2)=28
        mlength(3)=31 
        mlength(4)=30
        mlength(5)=31
        mlength(6)=30
        mlength(7)=31 
        mlength(8)=31
        mlength(9)=30
        mlength(10)=31
        mlength(11)=30
        mlength(12)=31 
        if (nd.eq.366) mlength(2)=29                        
       endif

      
       do iday = 1, nd
         imonth(iday) = 1
       end do
       iday1 = 1
       iday2 = mlength(1)
       do im = 2, nm
         iday1 = iday1 + mlength(im-1)
         iday2 = iday2 + mlength(im)
         do iday = iday1, iday2
            imonth(iday) = im
         end do
       end do        
           
       write(*,*)'Reads GCM grid'      
      
       write(*,*)'Reads GCM climatic fields' 
       
       ird_tmax=0
       ird_sol=1       
      
       elv_dir = '/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/'
     &     //'COSMO/GSWP3_Belgium/'
       GCMm_dir = trim(elv_dir)//'monthly/'
       GCMd_dir = trim(elv_dir)//'daily/'
                  
        
       open(20,file=trim(GCMm_dir)//'temMEAN1981_2010.dat')
       open(21,file=trim(GCMm_dir)//'dteMEAN1981_2010.dat')
       open(23,file=trim(GCMm_dir)//'prcMEAN1981_2010.dat')
       open(24,file=trim(GCMm_dir)//'fsolMEAN1981_2010.dat')
       open(25,file=trim(GCMm_dir)//'rhuMEAN1981_2010.dat')
       open(26,file=trim(GCMm_dir)//'wndMEAN1981_2010.dat') 

       open(30,file=trim(GCMd_dir)//'tem'//year//'.dat')       
       open(31,file=trim(GCMd_dir)//'dte'//year//'.dat')
       open(33,file=trim(GCMd_dir)//'prc'//year//'.dat')
       open(34,file=trim(GCMd_dir)//'fsol'//year//'.dat')
       open(35,file=trim(GCMd_dir)//'rhu'//year//'.dat')
       open(36,file=trim(GCMd_dir)//'wnd'//year//'.dat')
     

       do ig = 1, ngr_GCM
       
        read(20,*) xlo,xla,(tema(im),im=1,nm)
        xlg(ig)=xlo
        xlt(ig)=xla
        read(21,*) xlo,xla,(dtem(im),im=1,nm)		
	read(23,*) xlo,xla,(prec(im),im=1,nm)
	if (ird_sol.eq.0) then
	 read(24,*) xlo,xla,(sunh(im),im=1,nm)
	else
	 read(24,*) xlo,xla,(fsol(im),im=1,nm)	
	endif
	read(25,*) xlo,xla,(rhum(im),im=1,nm)
	read(26,*) xlo,xla,(wind(im),im=1,nm)
		
	do im=1,nm
	 if (dtem(im).lt.0.) then
	   write(*,*)'Negative dtem:',dtem(im),' pixel:',ig
     &              ,' month:',im,'year: MEAN'
	   dtem(im) = 0.
	 endif	
	end do

	read(30,*) xlo,xla,(tema1(iday),iday=1,nd)		
	read(31,*) xlo,xla,(dtem1(iday),iday=1,nd)	
	read(33,*) xlo,xla,(prec1(iday),iday=1,nd)
	if (ird_sol.eq.0) then
	 read(34,*) xlo,xla,(sunh1(iday),iday=1,nd)
	else
	 read(34,*) xlo,xla,(fsol1(iday),iday=1,nd)
	endif
	read(35,*) xlo,xla,(rhum1(iday),iday=1,nd)
	read(36,*) xlo,xla,(wind1(iday),iday=1,nd)
	do iday=1,nd
	 if (dtem1(iday).lt.0.) then
	   write(*,*)'Negative dtem:',dtem1(iday),' pixel:',ig
     &              ,' month:',iday,'year: ',year	   
	   dtem1(iday) = 0.
	 endif	
	end do	
		
	do iday = 1, nd
	 im = imonth(iday)
	 temp(ig,iday)=tema(im)
	 dtep(ig,iday)=dtem(im)
	 prcp(ig,iday)=prec(im)/float(mlength(im))  
	 if(rhum(im).lt.5.)rhum(im)=5.       
         if(rhum(im).gt.100.)rhum(im)=100.
	 rhup(ig,iday)=rhum(im)
         if (ird_sol.eq.0) then	 
          if(sunh(im).lt.0.)sunh(im)=0.       
          if(sunh(im).gt.100.)sunh(im)=100.
	  shrp(ig,iday)=sunh(im)
	 else
	  solp(ig,iday)=fsol(im)
	 endif
	 if (wind(im).lt.0.) then
	   write(*,*)'Negative wind:',wind(im),' pixel:',ig
     &              ,' month:',iday
	   wind(im) = 0.
	 endif	
	 wndp(ig,iday)=wind(im)	 
	 
	 tem1(ig,iday)=tema1(iday)
	 dte1(ig,iday)=dtem1(iday)	 
	 prc1(ig,iday)=prec1(iday)  
	 if(rhum1(iday).lt.5.)rhum1(iday)=5.       
         if(rhum1(iday).gt.100.)rhum1(iday)=100.
	 rhu1(ig,iday)=rhum1(iday)
         if (ird_sol.eq.0) then	 
          if(sunh1(iday).lt.0.)sunh1(iday)=0.       
          if(sunh1(iday).gt.100.)sunh1(iday)=100.
	  shr1(ig,iday)=sunh1(iday)
	 else
	  sol1(ig,iday)=fsol1(iday)
	 endif
	 if (wind1(iday).lt.0.) then
	   write(*,*)'Negative wind:',wind1(iday),' pixel:',ig
     &              ,' month:',iday
	   wind1(iday) = 0.
	 endif
	 wnd1(ig,iday)=wind1(iday)	 		 
	enddo 
       end do                   

       close(20)
       close(21)      
       close(22)
       close(23) 
       close(24)
       close(25)
       close(26)

       close(30)       
       close(31)      
       close(32)
       close(33) 
       close(34)
       close(35)
       close(36)
       
                  
c      end do
      
      write(*,*)'Interpolation'     
      
      open(10,file='./dist.res')  
               
      
c ================================================
c path to be changed by user     

c directory of high resolution files for 
      car_dir='/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/'
     &//'clim/Wallonia/COSMO_lprtqv/monthly/'
c   tem   
      open(51,file=trim(car_dir)//'temMEAN1981_2010.dat')
c   prc 
      open(52,file=trim(car_dir)//'prcMEAN1981_2010.dat')
c   shr / fsol
      if (ird_sol.eq.0) then
       open(53,file=trim(car_dir)//'shrMEAN1981_2010.dat')
      else		
       open(53,file=trim(car_dir)//'fsolMEAN1981_2010.dat')
      endif
c   rhu     
      open(54,file=trim(car_dir)//'rhuMEAN1981_2010.dat')
      if (ird_tmax.eq.0) then
c   dte      
       open(55,file=trim(car_dir)//'dteMEAN1981_2010.dat')
      else
c   Tmax, Tmin      
       open(57,file=trim(car_dir)//'tmaxMEAN1981_2010.dat')
       open(58,file=trim(car_dir)//'tminMEAN1981_2010.dat')     
      endif  
c   wnd           	      
      open(56,file=trim(car_dir)//'wndMEAN1981_2010.dat')

c directory for outputs      
      out_dir='/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/'
     &//'clim/Wallonia/COSMO_lprtqv/'     
     
      call make_directory(out_dir)
            
      open(81,file=trim(out_dir)//'temGSWP3_'//year//".dat")
      open(82,file=trim(out_dir)//'prcGSWP3_'//year//".dat")
      if (ird_sol.eq.0) then		
       open(83,file=trim(out_dir)//'shrGSWP3_'//year//".dat")
      else
       open(83,file=trim(out_dir)//'fsolGSWP3_'//year//".dat")
      endif
      open(84,file=trim(out_dir)//'rhuGSWP3_'//year//".dat")
      if (ird_tmax.eq.0) then
       open(85,file=trim(out_dir)//'dteGSWP3_'//year//".dat")
      else
       open(87,file=trim(out_dir)//'tmaxGSWP3_'//year//".dat")
       open(88,file=trim(out_dir)//'tminGSWP3_'//year//".dat")           
      endif	       
      open(86,file=trim(out_dir)//'wndGSWP3_'//year//".dat")

c=====================================================                           
      icount = 0
      do kg = 1, ngr_car
       icount=icount+1      
c       if (icount.eq.1)write(*,*)'Point Nr: ',kg
       if (icount.eq.1000)icount=0
c       read(50,*)mmm,xlg1,xlt1
       
       read(51,*)xlg1,xlt1,(tem0(im),im=1,nm)
       read(52,*)ylg,ylt,(prc0(im),im=1,nm)
c change units of monthly precipitation from mm/mo to mm/day       
       do im = 1, nm
        prc0(im)=prc0(im)/float(mlength(im))
       end do       
       if (ird_sol.eq.0) then
        read(53,*)ylg,ylt,(shr0(im),im=1,nm)
       else
        read(53,*)ylg,ylt,(sol0(im),im=1,nm)       
       endif
       read(54,*)ylg,ylt,(rhu0(im),im=1,nm)
       if (ird_tmax.eq.0) then        
        read(55,*)ylg,ylt,(dte0(im),im=1,nm)
       else
        read(57,*)ylg,ylt,(tmx0(im),im=1,nm)
	read(58,*)ylg,ylt,(tmn0(im),im=1,nm)       
       endif
       read(56,*)ylg,ylt,(wnd0(im),im=1,nm)
       do im = 1, nm
        if (rhu0(im).lt.5.) rhu0(im)=5.
        if (rhu0(im).gt.100.) rhu0(im)=100.
	if (ird_sol.eq.0) then
          if (shr0(im).lt.0.) shr0(im)=0.
          if (shr0(im).gt.100.) shr0(im)=100.
	endif 
       enddo
             
       dangl = 3. !(70./111.) !(25./111.)
       ntry = 0
2000   continue       
       num = 0
       do ig = 1, ngr_GCM
        dlg = dabs(xlg(ig)-xlg1)
c	dangl_lg = dangl/dcos(xlt(ig)*pi180)
	if(dlg.le.dangl)then	
c	 write(*,*) 'coucou'
	 dlt = dabs(xlt(ig)-xlt1)
	 if(dlt.le.dangl)then
c	  write(*,*) 'coucou2'
	  num=num+1
	  igri(num)=ig
	  xlg2 = xlg(ig)
	  xlt2 = xlt(ig)
c	   write(*,*) ig,xlg1,xlt1,xlg2,xlt2
c          write(*,*) ig,dlg,dangl,dangl_lg
          call distance(xlg1,xlt1,xlg2,xlt2,dist2)
	  dist(num)=dist2
c	  xdat(ig)=dist(ig)	
c	  write(*,*) dist(1) 
	 endif
	endif
       end do
       write(10,'(2(1x,f8.3),1x,i3)')xlg1,xlt1,num
       
       call sort(dist,igri,num)

       
       if (ntry.gt.100) then
         write(*,*)'Ntry too large: ', ntry,' ig: ',ig
	 stop
       endif 
       if (num.lt.npoints) then 
         dangl = dangl*1.5
	 ntry = ntry + 1
	 go to 2000
       endif        
       
       jdv=0
       
       call interp_r(temp,temact,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)       
       call interp_r(prcp,prcact,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv) 
       if (ird_sol.eq.0) then           
        call interp_r(shrp,shract,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)
       else
        call interp_r(solp,solact,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)       
       endif       
       call interp_r(rhup,rhuact,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)       
       if (ird_tmax.eq.0) then	 
        call interp_r(dtep,dteact,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)	 
       else
        call interp_r(tmxp,tmxact,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)	
	call interp_r(tmnp,tmnact,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)	
       endif     
       call interp_r(wndp,wndact,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)             
       call interp_r(tem1,temlgm,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)       
       call interp_r(prc1,prclgm,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)
       if (ird_sol.eq.0) then            
        call interp_r(shr1,shrlgm,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv) 
       else
        call interp_r(sol1,sollgm,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)       
       endif      
       call interp_r(rhu1,rhulgm,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)       
       if (ird_tmax.eq.0) then
        call interp_r(dte1,dtelgm,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)	 
       else
        call interp_r(tmx1,tmxlgm,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)	
	call interp_r(tmn1,tmnlgm,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)	
       endif       	       
       call interp_r(wnd1,wndlgm,elvp,elv,dvdz,dist,igri,npoints,npdv
     &           ,nd,jdv)             
      
c ---------- itest = -1  absolute correction -------------------------
c ---------- itest =  0  weighted aver. of abs. and rel. correct. ----
c ---------- itest =  1  relative correction -------------------------
       
       tcrit=1.
       tmini=273.
       itest=-1
       call correctd(tem0,temcor,temact,temlgm,tcrit,tmini,itest,nd,nm)
       
       pcrit=5.
       pmin=0.2
       itest=1
       call correctd(prc0,prccor,prcact,prclgm,pcrit,pmin,itest,nd,nm)
       do iday=1,nd
        if(prccor(iday).le.0.)then
         write(7,*)'negative precip :',kg,iday,xlg1,xlt1
         write(7,*)prc0(iday),prccor(iday),prcact(iday),prclgm(iday)	
	 prccor(iday)=0.
        endif	 
        if(prccor(iday).ge.1000.)then
         write(7,*)'too large precip :',kg,iday,xlg1,xlt1
         write(7,*)prc0(iday),prccor(iday),prcact(iday),prclgm(iday)
        endif
       end do
       
       if (ird_sol.eq.0) then       
        scrit=2.
        smin=0.1
        itest=0
        call correctd(shr0,shrcor,shract,shrlgm,scrit,smin,itest,nd,nm)
        do iday=1,nd
         if(shrcor(iday).lt.0.)shrcor(iday)=0.
         if(shrcor(iday).gt.100.)shrcor(iday)=100.
        end do
       else
        scrit=5.
        smin=0.2
        itest=0
        call correctd(sol0,solcor,solact,sollgm,scrit,smin,itest,nd,nm)
	do iday = 1, nd
         if(solcor(iday).le.0.)then
          write(7,*)'negative fsol :',kg,iday,xlg1,xlt1
          write(7,*)sol0(iday),solcor(iday),solact(iday),sollgm(iday)	
	  solcor(iday)=0.
         endif	 
         if(solcor(iday).ge.1100.)then
          write(7,*)'too large fsol :',kg,iday,xlg1,xlt1
          write(7,*)sol0(iday),solcor(iday),solact(iday),sollgm(iday)
         endif
	end do	       
       endif
       
       rcrit=2.
       rmin=0.1
       itest=0
       call correctd(rhu0,rhucor,rhuact,rhulgm,rcrit,rmin,itest,nd,nm)
       do iday=1,nd
        if(rhucor(iday).lt.0.)rhucor(iday)=0.
        if(rhucor(iday).gt.100.)rhucor(iday)=100.
       end do
       
       if (ird_tmax.eq.0) then              
        dcrit=1.
        dmin=0.1
        itest=-1
        call correctd(dte0,dtecor,dteact,dtelgm,dcrit,dmin,itest,nd,nm)
        do iday=1,nd
         if(dtecor(iday).lt.0.)dtecor(iday)=0.
        end do
       else
        tcrit=1.
        tmin=273.
        itest=-1
        call correctd(tmx0,tmxcor,tmxact,tmxlgm,tcrit,tmin,itest,nd,nm)
	call correctd(tmn0,tmncor,tmnact,tmnlgm,tcrit,tmin,itest,nd,nm)
        do iday=1,nd
         if(tmxcor(iday).lt.tmncor(iday))then
	   tmxcor(iday)=temcor(iday)
	   tmncor(iday)=temcor(iday)
	 endif
        end do	       
       endif
             
       wcrit=0.5
       wmin=0.1
       itest=1
       call correctd(wnd0,wndcor,wndact,wndlgm,wcrit,wmin,itest,nd,nm)
       do iday=1,nd
        if(wndcor(iday).lt.0.)wndcor(iday)=0.
       end do 

       write(wform,*)'(2(1x,f9.4),',nd,'(1x,f8.3))'                    
       write(81,wform)xlg1,xlt1,(temcor(iday),iday=1,nd)
       
       write(wform,*)'(2(1x,f9.4),',nd,'(1x,f10.3))'       
       write(82,wform)xlg1,xlt1,(prccor(iday),iday=1,nd)
       
       if (ird_sol.eq.0) then
        write(wform,*)'(2(1x,f9.4),',nd,'(1x,f8.3))'       
        write(83,wform)xlg1,xlt1,(shrcor(iday),iday=1,nd)
       else
        write(wform,*)'(2(1x,f9.4),',nd,'(1x,f8.3))'       
        write(83,wform)xlg1,xlt1,(solcor(iday),iday=1,nd)
       endif
       
       write(wform,*)'(2(1x,f9.4),',nd,'(1x,f8.3))'       
       write(84,wform)xlg1,xlt1,(rhucor(iday),iday=1,nd)
       
       if (ird_tmax.eq.0) then       
        write(wform,*)'(2(1x,f9.4),',nd,'(1x,f8.3))'       
        write(85,wform)xlg1,xlt1,(dtecor(iday),iday=1,nd)
       else
        write(wform,*)'(2(1x,f9.4),',nd,'(1x,f8.3))'       
        write(87,wform)xlg1,xlt1,(tmxcor(iday),iday=1,nd)
	write(88,wform)xlg1,xlt1,(tmncor(iday),iday=1,nd)        
       endif
       
       write(wform,*)'(2(1x,f9.4),',nd,'(1x,f8.3))'       
       write(86,wform)xlg1,xlt1,(wndcor(iday),iday=1,nd)       
              
      end do
      

      close (50)
      close (51)
      close (52)
      close (53)
      close (54)
      if (ird_tmax.eq.0) then      
       close (55)
      else
       close (57)
       close (58)
      endif
      close (56)
             
      close (81)
      close (82)
      close (83)
      close (84)
      if (ird_tmax.eq.0) then      
       close (85)
      else
       close (87)
       close (88)
      endif
      close (86)  
      
      end do
      
      write(*,*)'End of program'  
                        
      stop      
      end
      
c ********************************************************************** 
      subroutine interp_r(varint,vari,elvp,elv,dvdz,dist,idat,num,npdv
     &           ,nd,jdv)
c **********************************************************************
      implicit none      
 
      integer ndmx,ngrmx
      parameter (ngrmx=10000,ndmx=366)  

      integer idat(ngrmx),num,npdv,nd,jdv         
      real*8 varint(ngrmx,ndmx),vari(ndmx),dvdz(ndmx)
      real*8 elvp(ngrmx),dist(ngrmx),elv,delv
      
      integer m,k,ig
      real*8 sumwgt,weight
      
      if (jdv.eq.1)call zdep(elvp,varint,dvdz,dist,idat,npdv,nd)      
                  
      sumwgt = 0.
      do m = 1, nd
       vari(m)=0.
      end do      

      do k = 1, num
        ig = idat(k)
        delv = elv-elvp(ig)	
        if (dist(k).le.1.d-4) then	
	  do m = 1, nd
	   vari(m)=varint(ig,m)
	  end do
	  go to 1000
	else
	  weight = 1./dist(k)
	  sumwgt = sumwgt + weight
	  do m = 1, nd
	   if (jdv.eq.1) then
	    vari(m)=vari(m)+(varint(ig,m)+dvdz(m)*delv)*weight            
	   else
	    vari(m)=vari(m)+varint(ig,m)*weight
	   endif
	  end do
        endif
      end do
      
      do m = 1,nd
       vari(m) = vari(m)/sumwgt
      end do
      
1000  continue
      return
      end

      
c ********************************************************************** 
      subroutine zdep(elvp,varint,dvdz,dist,idat,npdv,nd)
c **********************************************************************
      implicit none            
 
      integer ndmx,ngrmx,ndeg
      parameter (ngrmx=10000,ndmx=366,ndeg=1)  

      integer idat(ngrmx),npdv,nd         
      real*8 elvp(ngrmx),varint(ngrmx,ndmx),dvdz(ndmx),dist(ngrmx)
      real*8 xi(npdv),yi(npdv),err
      real*8 aj(0:ndeg),cj(ndeg+1),sl(ndeg+1,ndeg+2)
      integer m,k,ig,ni
      
      do m = 1, nd
       ni=npdv
       do k = 1, npdv
        ig = idat(k)
	xi(k)=elvp(ig)
	yi(k)=varint(ig,m)       
       end do
       call polfit(xi,yi,ni,aj,ndeg,err,cj,sl) 
       dvdz(m)=aj(1)     
      end do       
      
      return
      end               
      
      
       
c ********************************************************************** 
      subroutine distance(xlg1,xlt1,xlg2,xlt2,distx)
c **********************************************************************
      implicit none      

      real*8 xlg1,xlt1,xlg2,xlt2,distx
      common /earth/ radius,pi180
      real*8 radius,pi180
      real*8 c1,c2,s1,s2,cdlg,argu
c 
c   xlg1,xlt1 = long, lat of first point (deg)
c   xlg2,xlt2 = long, lat of second point (deg)
c   radius = Earth radius (km)
c   pi180 = 3.1415926535/180. 
c   dist = distance (km)

c obligation de preciser l'arrondi pour passage a 1 ou -1 sinon
c  fonction acos considere que c'est hors dom def. (>1 ou <-1)
c  d'ou NAN

       c1 = dcos(xlt1*pi180)
       c2 = dcos(xlt2*pi180)
       s1 = dsin(xlt1*pi180)
       s2 = dsin(xlt2*pi180)       
       cdlg = dcos((xlg2-xlg1)*pi180) 
       argu = s1*s2+c1*c2*cdlg
       if (argu.ge.0.999999999)argu=0.999999999 
       if (argu.le.-0.999999999)argu=-0.999999999     
       distx = radius*dacos(argu)       
       
       
       return
       end
       

       
c=======================================================================      
       subroutine correctd(q0,qcor,qact,qlgm,qcrit,qmin,itest,nd,nm)
c=======================================================================       
c      This subroutine calculates absolute (dqabs) and relative (dqrel)
c      anomalies of a climatic variable q between a paleoclimatic (lgm) 
c      and a control (act) simulation of a climate model (GCM). 
c      These anomalies are combined with the observed value of q (q0
c      derived from a climatological database) to provide the corrected 
c      value (qcor) of q. The variable can be temperature, precipitation, 
c      relative humidity, etc, and nd=365 or 366 daily values are provided.
c      (Franois et al., Global Planet. Change 16-17, 37-52 1998)
c 
c      INPUTS (to be provided by the user)
c        q0 = observed daily values of the variable
c        qact = daily values of the variable in the GCM control run  
c        qlgm = daily values of the variable in the GCM paleoclimate
c               simulation
c        itest = flag to decide which type of anomalies is used for the
c                corrected value (qcor)
c                itest = -1 absolute anomalies are used
c                itest = 0  weighted averages of absolute and relative
c                           anomalies are used
c                itest = 1  relative anomalies are used         
c        qcrit = critical positive threshold in absolute corrected value 
c                used when itest = 0
c        qmin = parameter (small value) used to avoid excessively high 
c               values of relative anomalies when qact converge towards
c               zero
c        nd = number of days in the year
c      OUTPUT
c        qcor = corrected value of the variable
c-----------------------------------------------------------------------

       implicit none 
       integer ndmx,itest,iday,nd,nm,im
       parameter (ndmx=366)
       real*8 q0(nm),qcor(ndmx),qact(ndmx),qlgm(ndmx)
       real*8 qcrit,qmin
       real*8 puis,qabs,dqabs,dqrel,dqcor,xi,arg
       common /mth/ imonth(ndmx)
       integer imonth       
       
         puis=2.    
         do iday=1,nd
	 im = imonth(iday)
          dqabs=qlgm(iday)-qact(iday)
          qabs=q0(im)+dqabs
          dqrel=q0(im)*(qlgm(iday)-qact(iday))/(qact(iday)+qmin)
          if (itest.eq.-1) xi=1.
          if (itest.eq.1) xi=0.
          if (itest.eq.0) then
            if(qabs.le.0.)then
             xi=0.
            else
             arg=(qabs/qcrit)**puis
             if (arg.lt.30.)then
               xi=1.-dexp(-0.6931472*arg)
              else
               xi=1.
             endif
            endif
          endif
          dqcor=xi*dqabs+(1.-xi)*dqrel
          qcor(iday)=q0(im)+dqcor
         end do
       
       return
       end        
            
      
c=======================================================================      
      subroutine sort(xdat,idat,n)
c=======================================================================
     
      implicit none
      integer ngrmx
      parameter (ngrmx=10000)
      dimension xdat(ngrmx),idat(ngrmx)
      real*8 xdat,xdat2
      integer n,jtest,i,idat,idat2


100   continue      
      jtest = 0
     
      
      do i=1,n-1
        if (xdat(i).gt.xdat(i+1)) then
	  jtest = jtest+1
	  xdat2 = xdat(i+1)
	  idat2 = idat(i+1)
	  xdat(i+1) = xdat(i)
	  idat(i+1) = idat(i)
	  xdat(i) = xdat2
	  idat(i) = idat2
	endif
      end do
      
      if (jtest.ge.1) go to 100
      
      return
      end 
       
c***********************************************************************      
      subroutine make_directory(out_dir)
c***********************************************************************
      implicit none
      character*200 out_dir
      character*250 command 
 


      command='mkdir -p '//trim(out_dir)
      call system(command)      

 
      return
      end       
       
c=======================================================================
c***********************************************************************
      subroutine polfit(xi,yi,ni,aj,ndeg,err,cj,sl)
c***********************************************************************
c=======================================================================
c     Subroutine polfit performs a polynomial fit of a data set
c     The polynom has the form:
c       y = aj(0) + aj(1)*x + ... + aj(ndeg)*(x**ndeg)
c          xi = vector of dimension ni containing the x coordinates 
c               of the data
c          yi = vector of dimension ni containing the y coordinates 
c               of the data 
c          ni = number of data points
c          aj = vector of dimension (0:ndeg) containing the 
c               polynomial coefficients of the fit
c          ndeg = degree of the polynomial fit
c          err = sum of the squared differences 
c                err= sum_i=1,ni (y(xi)-yi)**2
c          cj = working vector of dimension ndeg+1
c          sl = working matrix of diomension (ndeg+1,ndeg+2)
c           (The dimensions of both working arrays has to be set 
c            in the main program)


      implicit none
c-----------------------------------------------
c JLP ajouté pour implicit none
c

      integer, intent(in) :: ni,ndeg
      integer i,j,k,nc,ne
      
      real*8  differ,sum,xij,xik,yical,aj,err,sl,xi,yi,cj
c
c-----------------------------------------------
      
      dimension xi(ni),yi(ni),aj(0:ndeg),cj(ndeg+1),sl(ndeg+1,ndeg+2)
      ne=ndeg+1
      nc=ndeg+2
      do 100 k=1,ne
         sum=0.
         do 200 i=1,ni
            call puiss(xi(i),k-1,xik)
            sum=sum+xik*yi(i)
 200     continue
      sl(k,nc)=sum
 100  continue
      do 300 k=1,ne
         do 400 j=1,ne
            sum=0.
            do 500 i=1,ni
               call puiss(xi(i),k-1,xik)
               call puiss(xi(i),j-1,xij)
               sum=sum+xik*xij
 500        continue
         sl(k,j)=sum
 400     continue
 300  continue
      call gauss(ne,sl,cj)
      do 600 j=0,ndeg
         aj(j)=cj(j+1)
 600  continue
      err=0.
      do 700 i=1,ni
         yical=aj(0)
         do 800 j=1,ndeg
            call puiss(xi(i),j,xij)
            yical=yical+aj(j)*xij
 800     continue
      differ=yical-yi(i)
      err=err+differ*differ
 700  continue
      return
      end

c=======================================================================
c***********************************************************************
      subroutine puiss(x,k,xk)
c***********************************************************************
c=======================================================================

      implicit none  
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer, intent(in) :: k
      integer :: i
      
      real*8, intent(in)  :: x
      real*8, intent(out) :: xk
c
c-----------------------------------------------
    
      xk=1.
      if(k.le.0)goto 200
      do 100 i=1,k
         xk=xk*x
 100  continue
      goto 400
 200  if(k.eq.0)goto 400
      do 300 i=1,-k
         xk=xk/x
 300  continue
 400  continue
      return
      end


c=======================================================================
c***********************************************************************
      subroutine gauss(ne,sl,x)
c***********************************************************************
c=======================================================================

      implicit none        
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer, intent(in) :: ne
      integer jc,je,jr,nc
      
      real*8  coeff1,diag,rsum,sl,x
c
c-----------------------------------------------
      
      dimension sl(ne,ne+1),x(ne)
c=======================================================================
c   Subroutine Gauss solves a system of simultaneous linear algebraic
c   equations by Gaussian elimination and back substitution.
c   The number of equations (equal to the number of unknowns) is ne. 
c   The coefficients are in array sl(ne,ne+1), where the last 
c   column is the constants on the right sides of the equations. 
c   The answers are returned in the array x(ne).
c=======================================================================
      nc=ne+1
      do 100 je=1,ne
         diag=sl(je,je)
         if(diag.eq.0.)call exch(ne,nc,je,sl,diag)
         do 200 jc=je,nc
            sl(je,jc)=sl(je,jc)/diag
 200     continue
         do 300 jr=je+1,ne
            coeff1=sl(jr,je)
            do 400 jc=je,nc
               sl(jr,jc)=sl(jr,jc)-sl(je,jc)*coeff1
 400        continue
 300     continue
 100  continue
      x(ne)=sl(ne,nc)
      do 500 je=ne-1,1,-1
         rsum=0.
         do 600 jc=je+1,nc-1
            rsum=rsum+x(jc)*sl(je,jc)
 600     continue
         x(je)=sl(je,nc)-rsum
 500  continue
      return
      end
      
c=======================================================================
c***********************************************************************
      subroutine exch(ne,nc,je,sl,diag)
c***********************************************************************

c=======================================================================
c     This subroutine exchanges rows to get a zero coefficient off the
c     diagonal.
c=======================================================================

      IMPLICIT NONE      
c-----------------------------------------------
c JLP ajout pour implicit none
c
      integer jc,je,jr,nc,ne
      real*8  diag,sl,temp
c
c-----------------------------------------------      
      dimension sl(ne,ne+1)            
      do 100 jr=je+1,ne
         if(sl(jr,je).eq.0.)goto 100
         do 200 jc=je,nc
            temp=sl(jr,jc)
            sl(jr,jc)=sl(je,jc)
            sl(je,jc)=temp
 200     continue
         diag=sl(je,je)
         goto 1000
 100  continue
      write(28,*) 'Zero element on the diagonal.' 
      write(28,*) 'Can not solve simultaneous equations.'
      stop
1000  continue
      return
      end
             
       
      
