c....&................................................................72
      implicit none
      integer nfile
      parameter (nfile=6)
      integer nlg_hr,nlt_hr,nlg_lr,nlt_lr,npix,ipix,nm,m,ilg,ilt,klg,klt
      integer neig_lg,neig_lt,num,ilg_hr,ilt_hr
c  npix : number of pixels (to be changed by user)      
      parameter (npix=171803,nm=12,nlg_hr=2400,nlt_hr=3000)
      real*4 xlg,xlt,var(nm)
      real*4 xlgmin,xltmin,dlg_hr,dlt_hr
      real*4 xlg_hr(nlg_hr),xlt_hr(nlt_hr),var_hr(nlg_hr,nlt_hr,nm)
      real*4 areal,parea,pi,fland,areatot
      character*4 varname(nfile)
      integer ifile
      varname(1) = 'tem'
      varname(2) = 'dte'
      varname(3) = 'prc'
      varname(4) = 'fsol'
      varname(5) = 'rhu'
      varname(6) = 'wnd'      
      
      do ifile = 1, nfile

c  name of input file for the mean (to be changed by user)      
      open(1,file=
     &'../clim/Belgium/WC2/'
     &//trim(varname(ifile))//'_WC.dat')
     
      pi=3.141592654
     
      neig_lg = 12
      neig_lt = 8

c  xlgmin, xltmin : minimum longitude and latitude of the zone 
c                  (to be changed by user)      
      xlgmin=1.75
      xltmin=49.25 
      dlg_hr=1./120.
      dlt_hr=1./120. 
      
      do ilg=1,nlg_hr
       xlg_hr(ilg)=xlgmin+(float(ilg)-0.5)*dlg_hr
      end do
      do ilt=1,nlt_hr
       xlt_hr(ilt)=xltmin+(float(ilt)-0.5)*dlt_hr
      end do  
      
      do ilg=1,nlg_hr
       do ilt=1,nlt_hr
        do m=1,nm
         var_hr(ilg,ilt,m)=-9999. 
	end do
       end do
      end do       
     
      do ipix = 1, npix
       read(1,*)xlg,xlt,(var(m),m=1,nm)
       ilg = 1 + int((xlg-xlgmin)/dlg_hr)
       ilt = 1 + int((xlt-xltmin)/dlt_hr)
       do m = 1, nm
        var_hr(ilg,ilt,m)=var(m)
       end do
      end do
      
      close (1)

c  name of output file for the mean (to be changed by user)      
      open(2,file=
     &'../clim/Belgium/MAR/'
     &//trim(varname(ifile))//'_WC.dat')

      do ilt = 1, nlt_hr, neig_lt      
       do ilg = 1, nlg_hr, neig_lg
         num = 0
	 areal = 0.
	 areatot = 0.
         do m=1,nm
	  var(m)=0.
	 end do
         do klg = 1, neig_lg
	  do klt = 1, neig_lt
	   ilg_hr = ilg+klg-1
	   ilt_hr = ilt+klt-1
	   if ((ilg_hr.le.nlg_hr).and.(ilt_hr.le.nlt_hr)) then
	    parea=1.23604306d+10*dlg_hr*dlt_hr
     &               *cos(xlt_hr(ilt_hr)*pi/180.)
            areatot=areatot+parea	   
	    if (var_hr(ilg_hr,ilt_hr,1).gt.-9000.) then
	     num=num+1
             areal = areal+parea
	     do m = 1, nm
	      var(m) = var(m)+var_hr(ilg_hr,ilt_hr,m)*parea
	     end do
	    endif
	   endif
	  end do
	 end do
	 if (num.ge.1) then
	     fland = areal/areatot 
	     do m = 1, nm
	      var(m) = var(m)/areal
	     end do
	     xlg = (xlg_hr(ilg)+xlg_hr(ilg+neig_lg-1))/2.	   
	     xlt = (xlt_hr(ilt)+xlt_hr(ilt+neig_lt-1))/2.
	     write(2,'(1x,f9.4,1x,f8.4,12(1x,f7.2))')xlg,xlt,
     &       (var(m),m=1,nm)
         endif
       end do
      end do
      

      end do
       
      
      stop
      end      
       
      
