c....&................................................................72
      implicit none
      integer ig,ngr,k,nk,nv,iv,igg,isu
c  caution: ngr cannot be too large, since one output file is created
c           per pixel      
      parameter (ngr=8,nk=12,nv=10)
      integer iyr,iyr0,iyrf,iyrs,vtype(nv)
      character*4 year,yr0,yrf
      character*10 region(ngr)
      character*60 form,model,period
      character*200 dir,dirr,dirout
      character*220 file_in(nv),file_out(ngr),fileco
      character*5 vname(nv),ext,extr,scen0,scen1,scen
      character*8 vunit(nv)
      real*4 xlg(ngr),xlt(ngr),elv(ngr),var(nv,ngr,nk),v(nk),xlon,xlat
      real*4 fl(ngr),cla,sil,san,col
      real*4 time
      
      iyr0=1901
      iyrf=2100
      iyrs=2006
      
      model='HadGEM2-A0'
      scen0='hist'
      scen1='rcp85'
      period='rcp85'
      
      region=['Siberia','Thailand','France','Haiti','Belgium',
     &        'Madagascar','Canada','Cameroun']
     
      fileco='/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/'//
     &'clim/climzones/ecotxt_zones.dat'
      
      dir='/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/'//
     &'clim/climzones/'//trim(model)//'/monthly/'
     
      dirr='/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/'//
     &'results/climzones/'//trim(model)//'/monthly/'     

      ext='.dat'
      extr='.res'     
      
      vname=['tem','dte','prc','shr','rhu','wnd','fsol',
     &       'alb','ts','grf']
      vunit=['(oC)','(oC)','(mm/mo)','(%)','(%)','(m/s)','(W/m2)',
     &       '    ','(oC)','(W/m2)']      
      vtype=[    0,    0,    0,    0,    0,    0,    0,
     &           1,   1,    1]       
      
      dirout='/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/'//
     &'clim/climzones/'
     
c ===================================================================      

      open(999,file=fileco)
           
      write(yr0,'(i4)')iyr0
      write(yrf,'(i4)')iyrf 
      
      do ig = 1, ngr     
       file_out(ig)=trim(dirout)//trim(model)//'_'//trim(period)
     &              //'_'//trim(region(ig))//yr0//'-'//yrf//'.txt'
       open(ig,file=file_out(ig))
      
c read ecotxt file
       read(999,*)igg,xlg(ig),xlt(ig),isu,cla,sil,san,elv(ig),col,fl(ig)
       
       write(ig,'(a20,1x,a10)')'Country:            ',trim(region(ig))       
       write(ig,'(a20,3x,f8.3)')'Longitude (deg.):   ',xlg(ig)
       write(ig,'(a20,3x,f8.3)')'Latitude (deg.):    ',xlt(ig)
       write(ig,'(a20,3x,f8.0)')'Elevation (m):      ',elv(ig)
       write(ig,'(a20,3x,f8.4)')'Land fraction:      ',fl(ig)
       write(form,'(a23,i3,a8)')'(31x,1x,a4,1x,a5,2x,a9,',nv,'(5x,a4))'
       write(ig,form)'year','month','time'
     &              ,(trim(vname(iv)),iv=1,nv)
       write(form,'(a23,i3,a8)')'(31x,5x,6x,2x,a9,',nv,'(1x,a8))' 
       write(ig,form)'(yr)'
     &              ,(trim(vunit(iv)),iv=1,nv)                                
      end do
      
      close (999)
 
      write(*,*)'Begins loop'
      
      do iyr=iyr0, iyrf
       write(year,'(i4)')iyr
       if (iyr.lt.iyrs) then 
         scen=scen0
       else
         scen=scen1
       endif
       do iv= 1, nv
        if (vtype(iv).eq.0) then      
         file_in(iv)=trim(dir)//trim(vname(iv))//'_'//trim(scen)//'_'
     &               //year//trim(ext)
        else
         file_in(iv)=trim(dirr)//trim(vname(iv))//'_'//trim(scen)//'_'
     &               //year//trim(extr)
        endif
        open(999,file=file_in(iv))       
        do ig = 1,ngr       
         read(999,*)xlon,xlat,(v(k),k=1,nk)
	 if ((iv.eq.1).and.(iyr.eq.iyr0)) then
	   xlg(ig)=xlon
	   xlt(ig)=xlat
	 endif
	 do k = 1, nk
	  var(iv,ig,k)=v(k)
	 end do
	end do
        close(999)
       end do 
       write(form,'(a25,i3,a10)')'(31x,1x,a4,1x,i5,2x,f9.4,',nv,
     &              '(1x,f8.3))'       
       do k = 1, nk
        time=float(iyr)+(float(k)-0.5)/12.
        do ig = 1, ngr
         write(ig,form)year,k,time,(var(iv,ig,k),iv=1,nv)
	end do
       end do
      end do
      
      do ig = 1, ngr
       close (ig)
      end do
       
      stop
      end      
       
       
      
