c....&................................................................72
c ngr= number of pixels (to be changed by user)
      parameter (nlt=360,nlg=720,nm=12,ngr=1859)
      dimension flash(0:nlg+1,0:nlt+1,nm),xlat(0:nlt+1),xlong(0:nlg+1)
      dimension flsh(nm)
      character*80 formatw
      
      open(8,file=
     &'/raid3/umccb/migou/home/francois/NASA_lightning/data.ascii')
      
      
      res_lt = 0.5
      res_lg = 0.5
      inclat = 1
      
      do ilt = 1, nlt
       do ilg = 1, nlg
         read(8,*)(flash(ilg,ilt,m),m=1,nm)
c UNITES : donnees en nbre flashes km-2 day-1
c conversion en nbre flashes km-2 mo-1
         do m = 1, nm
	  flash(ilg,ilt,m) = flash(ilg,ilt,m)*365./12.
	 end do	 
       end do
      end do
      
      do ilt = 1, nlt
       do m= 1, nm
        flash(0,ilt,m)=flash(nlg,ilt,m)
	flash(nlg+1,ilt,m)=flash(1,ilt,m)
       end do
      end do
      
      do ilg = 0, nlg+1
       do m= 1, nm
        flash(ilg,0,m)=flash(ilg,1,m)
	flash(ilg,nlt+1,m)=flash(ilg,nlt,m)
       end do
      end do
      
      do ilt = 0, nlt+1
        xlat(ilt)=float(ilt-1)*res_lt-90.+res_lt/2.
c        write(*,*)ilt,xlat(ilt)
      end do
      
      do ilg = 0, nlg+1
        xlong(ilg)=float(ilg-1)*res_lg-180.+res_lg/2.
c        write(*,*)ilg,xlong(ilg)
      end do 
      
c      open(11,file='./flash.dat')      
      
c      do ilt = 1, nlt
c       do ilg = 1, nlg 
c        write(formatw,*)'(f8.3,1x,f8.3,',nm,'(1x,1pe10.3))'
c        write(11,formatw)xlong(ilg),xlat(ilt),(flash(ilg,ilt,m),m=1,nm)
c       end do
c      end do   
      
      close (8)
c      close (9)
c      close (10)
c      close (11)

c path of input/output files (to be changed by user)      
      open(50,file='/raid3/umccb/clim0017/stughilain/'//
     &'caraib/clim/Belgium/MAR/ecotxt.dat')       
      open(51,file='/raid3/umccb/clim0017/stughilain/'//
     &'caraib/clim/Belgium/MAR/lightning.dat') 

      do igr=1,ngr     
      
        read(50,*)ngg,xlgr,xltr
	xlg=xlgr
        if(xlg.lt.xlong(0))xlg=xlg+360.
        if(xlg.gt.xlong(nlg+1))xlg=xlg-360.	
	xlt=xltr
        ilong=0
        do ilg=1,nlg+1
          if(xlong(ilg).lt.xlg)then
	    ilong=ilg
	  else
	    go to 1000
	  endif
        end do	
1000    continue
        ilat=0
        do ilt=1,nlt+1
	 if(inclat.eq.-1)then
          if(xlat(ilt).gt.xlt)then
	    ilat=ilt
	  else
	    go to 2000
	  endif
	 else
          if(xlat(ilt).lt.xlt)then
	    ilat=ilt
	  else
	    go to 2000
	  endif
	 endif	  
        end do	
2000    continue
        jlg1 = ilong
        jlg2 = ilong+1
        jlt1 = ilat
        jlt2 = ilat+1	
        dist_lg=(xlg-xlong(jlg1))/(xlong(jlg2)-xlong(jlg1))	 
	dist_lt=(xlt-xlat(jlt1))/(xlat(jlt2)-xlat(jlt1))
        if((dist_lg.lt.0).or.(dist_lg.gt.1.))then 
         write(7,*)'Unacceptable value for dist_lg:',dist_lg,xlg,xlt
        endif
        if((dist_lt.lt.0).or.(dist_lt.gt.1.))then 
         write(7,*)'Unacceptable value for dist_lt:',dist_lt,xlg,xlt
        endif	

        call interp(jlg1,jlg2,jlt1,jlt2,dist_lg,dist_lt,flash,flsh)

        write(formatw,*)'(f8.3,1x,f8.3,',nm,'(1x,1pe10.3))'
        write(51,formatw)xlgr,xltr,(flsh(m),m=1,nm)
       end do		      
           
      stop 
      end
      
c=======================================================================              
       subroutine interp(jlg1,jlg2,jlt1,jlt2,dist_lg,dist_lt,vari,var) 
c=======================================================================                   
       
       parameter (nlt=360,nlg=720,nm=12)        
                  
       dimension vari(0:nlg+1,0:nlt+1,nm),var(nm)


       do im=1,nm
	  var_1 = vari(jlg1,jlt1,im)
     &          +(vari(jlg2,jlt1,im)-vari(jlg1,jlt1,im))*dist_lg	 
	  var_2 = vari(jlg1,jlt2,im)
     &          +(vari(jlg2,jlt2,im)-vari(jlg1,jlt2,im))*dist_lg
          var(im)=var_1+(var_2-var_1)*dist_lt
       end do


       return
       end
